package lbms.plugins.mldht.kad;

/**
 * @author Damokles
 *
 */
public class KBucketEntryAndToken extends KBucketEntry {

	private Key	token;

	public KBucketEntryAndToken (KBucketEntry kbe, Key token) {
		super(kbe);
		this.token = token;
	}

	/**
	 * @return the token
	 */
	public Key getToken () {
		return token;
	}

	/* (non-Javadoc)
	 * @see lbms.plugins.mldht.kad.KBucketEntry#equals(java.lang.Object)
	 */
	@Override
	public boolean equals (Object obj) {
		if (obj instanceof KBucketEntryAndToken) {
			KBucketEntryAndToken kbet = (KBucketEntryAndToken) obj;
			if (super.equals(obj)) {
				return token.equals(kbet.token);
			} else {
				return false;
			}
		}
		return super.equals(obj);
	}

	/* (non-Javadoc)
	 * @see lbms.plugins.mldht.kad.KBucketEntry#hashCode()
	 */
	@Override
	public int hashCode () {
		return super.hashCode() ^ token.hashCode();
	}
}
