package lbms.plugins.mldht.kad.messages;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

import lbms.plugins.mldht.kad.DHT;
import lbms.plugins.mldht.kad.DHTConstants;
import lbms.plugins.mldht.kad.Key;

import org.gudy.azureus2.core3.util.BEncoder;

/**
 * @author Damokles
 *
 */
public class FindNodeResponse extends MessageBase {

	protected byte[]	nodes;

	/**
	 * @param mtid
	 * @param id
	 * @param nodes
	 */
	public FindNodeResponse (byte[] mtid, Key id, byte[] nodes) {
		super(mtid, Method.FIND_NODE, Type.RSP_MSG, id);
		this.nodes = nodes;
	}

	/* (non-Javadoc)
	 * @see lbms.plugins.mldht.kad.messages.MessageBase#apply(lbms.plugins.mldht.kad.DHT)
	 */
	@Override
	public void apply (DHT dh_table) {
		dh_table.response(this);
	}

	/* (non-Javadoc)
	 * @see lbms.plugins.mldht.kad.messages.MessageBase#encode()
	 */
	@Override
	public byte[] encode () throws IOException {
		Map<String, Object> base = new HashMap<String, Object>();
		Map<String, Object> inner = new HashMap<String, Object>();
		base.put(DHTConstants.RSP, inner);
		inner.put("id", id.getHash());
		inner.put("nodes", nodes);

		base.put(DHTConstants.TID, mtid);
		base.put(DHTConstants.TYP, DHTConstants.RSP);
		base.put(DHTConstants.VER, DHTConstants.getVersion());

		return BEncoder.encode(base);
	}

	/**
	 * @return the nodes
	 */
	public byte[] getNodes () {
		return nodes;
	}
	
	public String toString() {
		return super.toString() + "contains: "+ (nodes.length/26) + " nodes";
	}
}
